// IMKit-Anthy: A Qtopia InputMethod interface for Anthy
// Copyright (C) 2002  YamaKen <yamaken@bp.iij4u.or.jp>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// $Name: IMKIT_ANTHY_0_3_5_PRE_UTENA_902 $
// $Id: imwidget.cpp,v 1.2 2002/08/29 09:30:54 yamaken Exp $

#include <qapplication.h>
#include "imwidget.h"


QSize
imkit_screen_size(void) {
  return qApp->desktop()->size();
}

void
ActivatableQWidgetAdapter::set_activity(bool activity) {
  if (widget()) {
    if (activity) {
      widget()->show();
    } else {
      widget()->hide();
    }
  }
}

ActivatableQWidgetAdapter::ActivatableQWidgetAdapter(void) {
}

ActivatableQWidgetAdapter::~ActivatableQWidgetAdapter(void) {
}

bool
ActivatableQWidgetAdapter::is_active(void) const {
  const QWidget *const_widget;

  const_widget = ((ActivatableQWidgetAdapter *)this)->widget();

  return (const_widget && const_widget->isVisible());
}

Preedit::~Preedit(void) {
}

InputMapIndicator::~InputMapIndicator(void) {
}

CandidateWindow::~CandidateWindow(void) {
}

bool
InputMaskFilter::eventFilter(QObject *event_receiver, QEvent *e) {
  bool stopped;

  switch (e->type()) {
  case QEvent::MouseButtonPress:
  case QEvent::MouseButtonRelease:
  case QEvent::MouseButtonDblClick:
  case QEvent::MouseMove:
  case QEvent::KeyPress:
  case QEvent::KeyRelease:
  case QEvent::FocusIn:
  case QEvent::FocusOut:
  case QEvent::Enter:
  case QEvent::Leave:
  case QEvent::Wheel:
  case QEvent::DragEnter:
  case QEvent::DragMove:
  case QEvent::DragLeave:
  case QEvent::Drop:
  case QEvent::DragResponse:
    return (stopped = true);

  default:
    return (stopped = false);
  }
}
